Index: qtbase-everywhere-src-5.13.1/src/platformsupport/fontdatabases/freetype/qfontengine_ft_p.h
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/platformsupport/fontdatabases/freetype/qfontengine_ft_p.h
+++ qtbase-everywhere-src-5.13.1/src/platformsupport/fontdatabases/freetype/qfontengine_ft_p.h
@@ -101,11 +101,11 @@ public:
     FT_CharMap symbol_map;
 
     enum { cmapCacheSize = 0x200 };
-    glyph_t cmapCache[cmapCacheSize];
+    glyph__t cmapCache[cmapCacheSize];
 
     int fsType() const;
 
-    int getPointInOutline(glyph_t glyph, int flags, quint32 point, QFixed *xpos, QFixed *ypos, quint32 *nPoints);
+    int getPointInOutline(glyph__t glyph, int flags, quint32 point, QFixed *xpos, QFixed *ypos, quint32 *nPoints);
 
     bool isScalableBitmap() const;
 
@@ -155,14 +155,14 @@ public:
 
     struct GlyphAndSubPixelPosition
     {
-        GlyphAndSubPixelPosition(glyph_t g, QFixed spp) : glyph(g), subPixelPosition(spp) {}
+        GlyphAndSubPixelPosition(glyph__t g, QFixed spp) : glyph(g), subPixelPosition(spp) {}
 
         bool operator==(const GlyphAndSubPixelPosition &other) const
         {
             return glyph == other.glyph && subPixelPosition == other.subPixelPosition;
         }
 
-        glyph_t glyph;
+        glyph__t glyph;
         QFixed subPixelPosition;
     };
 
@@ -173,19 +173,19 @@ public:
         FT_Matrix transformationMatrix;
         bool outline_drawing;
 
-        void removeGlyphFromCache(glyph_t index, QFixed subPixelPosition);
+        void removeGlyphFromCache(glyph__t index, QFixed subPixelPosition);
         void clear();
-        inline bool useFastGlyphData(glyph_t index, QFixed subPixelPosition) const {
+        inline bool useFastGlyphData(glyph__t index, QFixed subPixelPosition) const {
             return (index < 256 && subPixelPosition == 0);
         }
-        inline Glyph *getGlyph(glyph_t index, QFixed subPixelPosition = 0) const;
-        void setGlyph(glyph_t index, QFixed spp, Glyph *glyph);
+        inline Glyph *getGlyph(glyph__t index, QFixed subPixelPosition = 0) const;
+        void setGlyph(glyph__t index, QFixed spp, Glyph *glyph);
 
-        inline bool isGlyphMissing(glyph_t index) const { return missing_glyphs.contains(index); }
-        inline void setGlyphMissing(glyph_t index) const { missing_glyphs.insert(index); }
+        inline bool isGlyphMissing(glyph__t index) const { return missing_glyphs.contains(index); }
+        inline void setGlyphMissing(glyph__t index) const { missing_glyphs.insert(index); }
 private:
         mutable QHash<GlyphAndSubPixelPosition, Glyph *> glyph_data; // maps from glyph index to glyph data
-        mutable QSet<glyph_t> missing_glyphs;
+        mutable QSet<glyph__t> missing_glyphs;
         mutable Glyph *fast_glyph_data[256]; // for fast lookup of glyphs < 256
         mutable int fast_glyph_count;
     };
@@ -213,14 +213,14 @@ private:
     QFixed lineThickness() const override;
     QFixed underlinePosition() const override;
 
-    glyph_t glyphIndex(uint ucs4) const override;
+    QGlyph glyphIndex(uint ucs4) const override;
     void doKerning(QGlyphLayout *, ShaperFlags) const override;
 
-    void getUnscaledGlyph(glyph_t glyph, QPainterPath *path, glyph_metrics_t *metrics) override;
+    void getUnscaledGlyph(const QGlyph &glyph, QPainterPath *path, glyph_metrics_t *metrics) override;
 
     bool supportsTransformation(const QTransform &transform) const override;
 
-    void addGlyphsToPath(glyph_t *glyphs, QFixedPoint *positions, int nglyphs,
+    void addGlyphsToPath(const QGlyph *glyphs, QFixedPoint *positions, int nglyphs,
                  QPainterPath *path, QTextItem::RenderFlags flags) override;
     void addOutlineToPath(qreal x, qreal y, const QGlyphLayout &glyphs,
                   QPainterPath *path, QTextItem::RenderFlags flags) override;
@@ -228,27 +228,27 @@ private:
     bool stringToCMap(const QChar *str, int len, QGlyphLayout *glyphs, int *nglyphs, ShaperFlags flags) const override;
 
     glyph_metrics_t boundingBox(const QGlyphLayout &glyphs) override;
-    glyph_metrics_t boundingBox(glyph_t glyph) override;
-    glyph_metrics_t boundingBox(glyph_t glyph, const QTransform &matrix) override;
+    glyph_metrics_t boundingBox(const QGlyph &glyph) override;
+    glyph_metrics_t boundingBox(const QGlyph &glyph, const QTransform &matrix) override;
 
     void recalcAdvances(QGlyphLayout *glyphs, ShaperFlags flags) const override;
-    QImage alphaMapForGlyph(glyph_t g) override { return alphaMapForGlyph(g, 0); }
-    QImage alphaMapForGlyph(glyph_t, QFixed) override;
-    QImage alphaMapForGlyph(glyph_t glyph, QFixed subPixelPosition, const QTransform &t) override;
-    QImage alphaRGBMapForGlyph(glyph_t, QFixed subPixelPosition, const QTransform &t) override;
-    QImage bitmapForGlyph(glyph_t, QFixed subPixelPosition, const QTransform &t, const QColor &color) override;
-    glyph_metrics_t alphaMapBoundingBox(glyph_t glyph,
+    QImage alphaMapForGlyph(const QGlyph &g) override { return alphaMapForGlyph(g, 0); }
+    QImage alphaMapForGlyph(const QGlyph &, QFixed) override;
+    QImage alphaMapForGlyph(const QGlyph &glyph, QFixed subPixelPosition, const QTransform &t) override;
+    QImage alphaRGBMapForGlyph(const QGlyph &, QFixed subPixelPosition, const QTransform &t) override;
+    QImage bitmapForGlyph(const QGlyph &, QFixed subPixelPosition, const QTransform &t, const QColor &color) override;
+    glyph_metrics_t alphaMapBoundingBox(const QGlyph & glyph,
                                         QFixed subPixelPosition,
                                         const QTransform &matrix,
                                         QFontEngine::GlyphFormat format) override;
-    QImage *lockedAlphaMapForGlyph(glyph_t glyph, QFixed subPixelPosition,
+    QImage *lockedAlphaMapForGlyph(const QGlyph &glyph, QFixed subPixelPosition,
                                    GlyphFormat neededFormat, const QTransform &t,
                                    QPoint *offset) override;
     bool hasInternalCaching() const override { return cacheEnabled; }
     void unlockAlphaMapForGlyph() override;
     bool expectsGammaCorrectedBlending() const override;
 
-    void removeGlyphFromCache(glyph_t glyph) override;
+    void removeGlyphFromCache(const QGlyph & glyph) override;
     int glyphMargin(QFontEngine::GlyphFormat /* format */) override { return 0; }
 
     int glyphCount() const override;
@@ -270,7 +270,7 @@ private:
     inline Glyph *loadGlyph(uint glyph, QFixed subPixelPosition, GlyphFormat format = Format_None, bool fetchMetricsOnly = false, bool disableOutlineDrawing = false) const
     { return loadGlyph(cacheEnabled ? &defaultGlyphSet : 0, glyph, subPixelPosition, format, fetchMetricsOnly, disableOutlineDrawing); }
     Glyph *loadGlyph(QGlyphSet *set, uint glyph, QFixed subPixelPosition, GlyphFormat = Format_None, bool fetchMetricsOnly = false, bool disableOutlineDrawing = false) const;
-    Glyph *loadGlyphFor(glyph_t g, QFixed subPixelPosition, GlyphFormat format, const QTransform &t, bool fetchBoundingBox = false, bool disableOutlineDrawing = false);
+    Glyph *loadGlyphFor(glyph__t g, QFixed subPixelPosition, GlyphFormat format, const QTransform &t, bool fetchBoundingBox = false, bool disableOutlineDrawing = false);
 
     QGlyphSet *loadGlyphSet(const QTransform &matrix);
 
@@ -282,7 +282,7 @@ private:
     bool init(FaceId faceId, bool antialias, GlyphFormat format,
               QFreetypeFace *freetypeFace);
 
-    int getPointInOutline(glyph_t glyph, int flags, quint32 point, QFixed *xpos, QFixed *ypos, quint32 *nPoints) override;
+    int getPointInOutline(glyph__t glyph, int flags, quint32 point, QFixed *xpos, QFixed *ypos, quint32 *nPoints) override;
 
     void setQtDefaultHintStyle(QFont::HintingPreference hintingPreference);
     void setDefaultHintStyle(HintStyle style) override;
@@ -347,7 +347,7 @@ inline uint qHash(const QFontEngineFT::G
     return (g.glyph << 8)  | (g.subPixelPosition * 10).round().toInt();
 }
 
-inline QFontEngineFT::Glyph *QFontEngineFT::QGlyphSet::getGlyph(glyph_t index, QFixed subPixelPosition) const
+inline QFontEngineFT::Glyph *QFontEngineFT::QGlyphSet::getGlyph(glyph__t index, QFixed subPixelPosition) const
 {
     if (useFastGlyphData(index, subPixelPosition))
         return fast_glyph_data[index];
Index: qtbase-everywhere-src-5.13.1/src/opengl/gl2paintengineex/qpaintengineex_opengl2.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/opengl/gl2paintengineex/qpaintengineex_opengl2.cpp
+++ qtbase-everywhere-src-5.13.1/src/opengl/gl2paintengineex/qpaintengineex_opengl2.cpp
@@ -1582,7 +1582,7 @@ void QGL2PaintEngineEx::drawTextItem(con
 
     if (shouldDrawCachedGlyphs(ti.fontEngine, s->matrix)) {
         QVarLengthArray<QFixedPoint> positions;
-        QVarLengthArray<glyph_t> glyphs;
+        QVarLengthArray<QGlyph> glyphs;
         QTransform matrix = QTransform::fromTranslate(p.x(), p.y());
         ti.fontEngine->getGlyphPositions(ti.glyphs, matrix, ti.flags, glyphs, positions);
 
Index: qtbase-everywhere-src-5.13.1/src/opengl/gl2paintengineex/qtextureglyphcache_gl.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/opengl/gl2paintengineex/qtextureglyphcache_gl.cpp
+++ qtbase-everywhere-src-5.13.1/src/opengl/gl2paintengineex/qtextureglyphcache_gl.cpp
@@ -280,7 +280,7 @@ void QGLTextureGlyphCache::resizeTexture
     }
 }
 
-void QGLTextureGlyphCache::fillTexture(const Coord &c, glyph_t glyph, QFixed subPixelPosition)
+void QGLTextureGlyphCache::fillTexture(const Coord &c, const QGlyph &glyph, QFixed subPixelPosition)
 {
     QGLContext *ctx = const_cast<QGLContext *>(QGLContext::currentContext());
     if (ctx == 0) {
Index: qtbase-everywhere-src-5.13.1/src/plugins/platforms/xcb/nativepainting/qpaintengine_x11.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/plugins/platforms/xcb/nativepainting/qpaintengine_x11.cpp
+++ qtbase-everywhere-src-5.13.1/src/plugins/platforms/xcb/nativepainting/qpaintengine_x11.cpp
@@ -228,7 +228,7 @@ public:
     ~QXRenderGlyphCache();
 
     bool addGlyphs(const QTextItemInt &ti,
-                   const QVarLengthArray<glyph_t> &glyphs,
+                   const QVarLengthArray<QGlyph> &glyphs,
                    const QVarLengthArray<QFixedPoint> &positions);
     bool draw(Drawable src, Drawable dst, const QTransform &matrix, const QTextItemInt &ti);
 
@@ -239,7 +239,7 @@ public:
     inline const XRenderPictFormat *renderPictFormat() const;
 
     static inline QFontEngine::GlyphFormat glyphFormatForDepth(QFontEngine *fontEngine, int depth);
-    static inline Glyph glyphId(glyph_t glyph, QFixed subPixelPosition);
+    static inline Glyph glyphId(glyph__t glyph, QFixed subPixelPosition);
 
     static inline bool isValidCoordinate(const QFixedPoint &fp);
 
@@ -2464,7 +2464,7 @@ void QX11PaintEngine::drawTextItem(const
 
 #if QT_CONFIG(fontconfig)
 static bool path_for_glyphs(QPainterPath *path,
-                            const QVarLengthArray<glyph_t> &glyphs,
+                            const QVarLengthArray<QGlyph> &glyphs,
                             const QVarLengthArray<QFixedPoint> &positions,
                             const QFontEngineFT *ft)
 {
@@ -2474,7 +2474,7 @@ static bool path_for_glyphs(QPainterPath
     ft->lockFace();
     int i = 0;
     while (i < glyphs.size()) {
-        QFontEngineFT::Glyph *glyph = ft->loadGlyph(glyphs[i], 0, QFontEngineFT::Format_Mono);
+        QFontEngineFT::Glyph *glyph = ft->loadGlyph(glyphs[i].glyph, 0, QFontEngineFT::Format_Mono);
         // #### fix case where we don't get a glyph
         if (!glyph || glyph->format != QFontEngineFT::Format_Mono) {
             result = false;
@@ -2541,7 +2541,7 @@ void QX11PaintEngine::drawFreetype(const
     transform.translate(p.x(), p.y());
 
     QVarLengthArray<QFixedPoint> positions;
-    QVarLengthArray<glyph_t> glyphs;
+    QVarLengthArray<QGlyph> glyphs;
     ti.fontEngine->getGlyphPositions(ti.glyphs, transform, ti.flags, glyphs, positions);
 
     if (glyphs.count() == 0)
@@ -2615,7 +2615,7 @@ QXRenderGlyphCache::~QXRenderGlyphCache(
 }
 
 bool QXRenderGlyphCache::addGlyphs(const QTextItemInt &ti,
-                                   const QVarLengthArray<glyph_t> &glyphs,
+                                   const QVarLengthArray<QGlyph> &glyphs,
                                    const QVarLengthArray<QFixedPoint> &positions)
 {
     Q_ASSERT(ti.fontEngine->type() == QFontEngine::Freetype);
@@ -2627,20 +2627,20 @@ bool QXRenderGlyphCache::addGlyphs(const
 
     for (int i = 0; i < glyphs.size(); ++i) {
         const QFixed spp = ft->subPixelPositionForX(positions[i].x);
-        QFontEngineFT::Glyph *glyph = set->getGlyph(glyphs[i], spp);
-        Glyph xglyphid = qHash(QFontEngineFT::GlyphAndSubPixelPosition(glyphs[i], spp));
+        QFontEngineFT::Glyph *glyph = set->getGlyph(glyphs[i].glyph, spp);
+        Glyph xglyphid = qHash(QFontEngineFT::GlyphAndSubPixelPosition(glyphs[i].glyph, spp));
 
         if (glyph && glyph->format == glyphFormat()) {
             if (cachedGlyphs.contains(xglyphid)) {
                 continue;
             } else {
-                set->setGlyph(glyphs[i], spp, nullptr);
+                set->setGlyph(glyphs[i].glyph, spp, nullptr);
                 delete glyph;
                 glyph = 0;
             }
         }
 
-        glyph = ft->loadGlyphFor(glyphs[i], spp, glyphFormat(), transform());
+        glyph = ft->loadGlyphFor(glyphs[i].glyph, spp, glyphFormat(), transform());
 
         if (glyph == 0 || glyph->format != glyphFormat())
             return false;
@@ -2652,7 +2652,7 @@ bool QXRenderGlyphCache::addGlyphs(const
             memcpy(glyph->data, img.constBits(), static_cast<size_t>(img.sizeInBytes()));
         }
 
-        set->setGlyph(glyphs[i], spp, glyph);
+        set->setGlyph(glyphs[i].glyph, spp, glyph);
         Q_ASSERT(glyph->data || glyph->width == 0 || glyph->height == 0);
 
         xglyphinfo.width = glyph->width;
@@ -2679,7 +2679,7 @@ bool QXRenderGlyphCache::draw(Drawable s
     QFontEngineFT *ft = static_cast<QFontEngineFT *>(ti.fontEngine);
     QFontEngineFT::QGlyphSet *set = ft->loadGlyphSet(matrix);
 
-    QVarLengthArray<glyph_t> glyphs;
+    QVarLengthArray<QGlyph> glyphs;
     QVarLengthArray<QFixedPoint> positions;
     ti.fontEngine->getGlyphPositions(ti.glyphs, matrix, ti.flags, glyphs, positions);
 
@@ -2692,7 +2692,7 @@ bool QXRenderGlyphCache::draw(Drawable s
     QVarLengthArray<unsigned int> chars(glyphs.size());
 
     for (int i = 0; i < glyphs.size(); ++i)
-        chars[i] = glyphId(glyphs[i], ft->subPixelPositionForX(positions[i].x));
+        chars[i] = glyphId(glyphs[i].glyph, ft->subPixelPositionForX(positions[i].x));
 
     int i = 0;
     while (i < glyphs.size() && !isValidCoordinate(positions[i]))
@@ -2719,7 +2719,7 @@ bool QXRenderGlyphCache::draw(Drawable s
             break;
 
         const QFixed spp = ft->subPixelPositionForX(positions[i].x);
-        QFontEngineFT::Glyph *g = set->getGlyph(glyphs[i], spp);
+        QFontEngineFT::Glyph *g = set->getGlyph(glyphs[i].glyph, spp);
 
         if (g
             && positions[i].x == xp + g->advance
@@ -2843,7 +2843,7 @@ QFontEngine::GlyphFormat QXRenderGlyphCa
     return glyphFormat;
 }
 
-Glyph QXRenderGlyphCache::glyphId(glyph_t glyph, QFixed subPixelPosition)
+Glyph QXRenderGlyphCache::glyphId(glyph__t glyph, QFixed subPixelPosition)
 {
     return qHash(QFontEngineFT::GlyphAndSubPixelPosition(glyph, subPixelPosition));
 }
